## Measurements

This report was generated with the measure-analysis.py script.
JSON formated measures were imported in the measures folder using the import functionnality of the script, this report was then generated using these measures.
Metadata is included with the measures, such as the kernel version used, the boot parameters passed, various others parameters specific to the measure, etc... 
Measures measuring the same propriety are grouped together in tables and graphs, and are identified by their diverging metadatas. This is useful to analyse the effect of specific parameters on the  measured propriety.

 Currently, most of the measures need to be redone, as the code for sending the packets has changed and gave different results.

### Description of the metadata associated to each test

* **ker**: Linux kernel version used
* **prio**: Priority of the real-time thread
* **i**: Interval between each packet transmission
* **board**: Name of the board used, one of three : Emerald, Slate or Onyx. (All boards are identical)
* **boot_p**: Boot Parameters passed to u-boot
* **delta**: ETF qdisc delta value
* **load**: External device and processor load during the test
* **duration**: Duration of the test
* **etf_offset**: When a packet's txtime is scheduled, the txtime set is the current time offset by etf_offset
* **route**: How the boards are connected. 'switch' means they are connected by a switch (cheap, unmanaged), 'E2E'means they are directly connected end to end

### cyclictest_wake-up_latency results

Uses cyclictest from the rt-tests test suite to measure wake-up latency. A real-time thread is run on CPU1, and wakes up at a regular interval (specified by the interval parameter) using clock_nanosleep. It then uses clock_gettime and computes the difference between the scheduled wake-up time and the effective wake-up time measured by clock_gettime. The command used is: cyclictest -p `prio` -a1 -t1 -n -h 200 -q -i `interval`

**Common test metadata:** Linux kernel version: 4.19, Boot Parameters: isolcpus, Interval: 200us, ETF qdisc delta: 200us, Task priority: 99, qdisc: pfifo_fast, etf_offset: none, route: switch

Metadata                  | Minimum             | Maximum             | Average             | Standard deviation 
------------------------- | ------------------- | ------------------- | ------------------- | -------------------
**board, duration, load** | **wake-up latency** | **wake-up latency** | **wake-up latency** | **wake-up latency**
Slate, 21h22, hackbench   | 14.0000us           | 65.0000us           | 21.2779us           | 2.1746us           
Emerald, 21h22, hackbench | 14.0000us           | 112.0000us          | 19.5352us           | 2.0136us           
Onyx, 46h, hackbench      | 14.0000us           | 72.0000us           | 20.5580us           | 1.9820us           
Emerald, 24h, ssh         | 12.0000us           | 80.0000us           | 15.4101us           | 1.1091us           

![alt text](measures/graphs/cyclictest_wake-up_latencywake-up latency.png "cyclictest_wake-up_latency Graph")

### packet_send_timestamps results

Similar to packet_recv_timestamps, but on the transmitting board. 

**Common test metadata:** Linux kernel version: 4.19, Boot Parameters: isolcpus, Task priority: 99, Device and processor load: ssh, etf_offset: none, route: switch

Metadata                                | Minimum                       | Maximum                       | Average                       | Standard deviation           
--------------------------------------- | ----------------------------- | ----------------------------- | ----------------------------- | -----------------------------
**board, i, duration, delta, qdisc**    | **user_space - kernel_space** | **user_space - kernel_space** | **user_space - kernel_space** | **user_space - kernel_space**
Onyx, 100000us, 0h17, 200us, pfifo_fast | 2.0000us - 42.0000us          | 12.0000us - 145.0000us        | 2.3099us - 51.8681us          | 0.5212us - 7.5021us          
Slate, 1000us, 1h00, 200us, pfifo_fast  | 1.0000us - 32.0000us          | 12.0000us - 222.0000us        | 2.0360us - 36.6218us          | 0.2221us - 3.0259us          
Slate, 1000us, 0h2, 200us, pfifo_fast   | 1.0000us - 32.0000us          | 12.0000us - 118.0000us        | 1.9341us - 36.6011us          | 0.2771us - 1.9293us          
Onyx, 1000us, 72h24, 160us, etf         | 1.0000us - 33.0000us          | 65.0000us - 110.0000us        | 1.9916us - 37.1342us          | 1.7622us - 3.6937us          

![alt text](measures/graphs/packet_send_timestampsuser_space.png "packet_send_timestamps Graph")

![alt text](measures/graphs/packet_send_timestampskernel_space.png "packet_send_timestamps Graph")

### packet_recv_timestamps results

An UDP packet is periodically sent from one board to another using a real time thread. The receiving board uses the SO_TIMESTAMPING option to see when the packet entered the kernel, and generates timestamps with clock_gettime once the packets enters userspace to compute the time the packet spent in kernel and user space.

**Common test metadata:** Linux kernel version: 4.19, Boot Parameters: isolcpus, Task priority: 99, Device and processor load: ssh, etf_offset: none, route: switch

Metadata                                 | Minimum                       | Maximum                       | Average                       | Standard deviation           
---------------------------------------- | ----------------------------- | ----------------------------- | ----------------------------- | -----------------------------
**i, duration, board, delta, qdisc**     | **user_space - kernel_space** | **user_space - kernel_space** | **user_space - kernel_space** | **user_space - kernel_space**
100000us, 0h17, Slate, 200us, pfifo_fast | 0.0000us - 44.0000us          | 26.0000us - 142.0000us        | 0.1151us - 55.4212us          | 0.4057us - 7.6346us          
1000us, 16h48, Slate, 200us, pfifo_fast  | 0.0000us - 35.0000us          | 41.0000us - 233.0000us        | 0.0036us - 41.5560us          | 0.2282us - 5.1991us          
1000us, 72h24, Emerald, 160us, etf       | 0.0000us - 41.0000us          | 42.0000us - 291.0000us        | 0.0235us - 50.7618us          | 0.3294us - 7.4393us          

![alt text](measures/graphs/packet_recv_timestampsuser_space.png "packet_recv_timestamps Graph")

![alt text](measures/graphs/packet_recv_timestampskernel_space.png "packet_recv_timestamps Graph")

### packet_jitter results

An UDP packet is periodically sent from one board to another using a real time thread. The receiving board calculates the intervals between the packets it receives, and sees how much it differs from the scheduled interval.

**Common test metadata:** Linux kernel version: 4.19, Boot Parameters: isolcpus, Task priority: 99, Device and processor load: ssh

Metadata                                                | Minimum     | Maximum    | Average    | Standard deviation
------------------------------------------------------- | ----------- | ---------- | ---------- | ------------------
**i, duration, board, delta, qdisc, etf_offset, route** | **jitter**  | **jitter** | **jitter** | **jitter**        
100000us, 0h17, Slate, none, pfifo_fast, none, switch   | -139.0000us | 147.0000us | 10.4314us  | 15.8981us         
1000us, 16h48, Slate, none, pfifo_fast, none, switch    | -434.0000us | 237.0000us | 6.9930us   | 9.0448us          
1000us, 72h24, Emerald, 160us, etf, 1000000, switch     | -397.0000us | 369.0000us | 7.4514us   | 12.4505us         
1000us, 0h15, Onyx, 150us, etf, 400, switch             | -535.0000us | 125.0000us | 10.5255us  | 12.8854us         
1000us, 0h12, Emerald, 150us, etf, 400, E2E             | -692.0000us | 129.0000us | 9.7386us   | 12.4607us         

![alt text](measures/graphs/packet_jitterjitter.png "packet_jitter Graph")

### packet_rtt results

An UDP packet is periodically sent from one board to another and sent back as soon as it arrives using a real time thread. The round trip time is computed with clock_gettime on the transmitting board.

**Common test metadata:** Board name: Onyx, Linux kernel version: 4.19, Boot Parameters: isolcpus, Interval: 10000us, ETF qdisc delta: 200us, Task priority: 99, Device and processor load: ssh, Test duration: 0h4, qdisc: pfifo_fast, etf_offset: none, route: switch

Minimum    | Maximum    | Average    | Standard deviation
---------- | ---------- | ---------- | ------------------
**rtt**    | **rtt**    | **rtt**    | **rtt**           
636.0000us | 972.0000us | 674.0051us | 15.5468us         

![alt text](measures/graphs/packet_rttrtt.png "packet_rtt Graph")

### packet_jitter_tcpdump results

**Common test metadata:** Board name: Onyx, Linux kernel version: 4.19, Boot Parameters: isolcpus, Interval: 1000, Task priority: 99, Device and processor load: ssh

Metadata                                      | Minimum    | Maximum    | Average    | Standard deviation
--------------------------------------------- | ---------- | ---------- | ---------- | ------------------
**delta, duration, qdisc, etf_offset, route** | **jitter** | **jitter** | **jitter** | **jitter**        
150us, 0h1, etf, 300us, switch                | -60.0000us | 90.0000us  | 12.0601us  | 13.9270us         
none, 0h2, pfifo_fast, none, E2E              | -113.0000us | 156.0000us | 14.5193us  | 18.0703us         

![alt text](measures/graphs/packet_jitter_tcpdumpjitter.png "packet_jitter_tcpdump Graph")


