#ifndef RECV_PACKET
#define RECV_PACKET

#include "utilities.h"

#ifdef WITH_XDP
#define NUM_FRAMES 4096
#define FRAME_SIZE XSK_UMEM__DEFAULT_FRAME_SIZE

struct xsk_umem_info {
  struct xsk_ring_prod fq;
  struct xsk_ring_cons cq;
  struct xsk_umem *umem;
  void *buffer;
};
struct xdpsock {
  struct xsk_ring_cons rx;
  struct xsk_ring_prod tx;
  struct xsk_umem_info umem;
  struct xsk_socket *xsk;
  int fd;
};
#endif


int init_udp_recv(int use_timestamps, char *network_if);
packet_info_t recv_udp_packet(int use_timestamps, int use_histograms, int64_t histograms[NB_HISTOGRAMS][MAX_HIST_VAL]);

void init_xdp_recv(char *network_if);
int recv_xdp_packet(struct timespec *ts);

#endif
